// OE2.h - OutlookExpress-To - OE5/6 Multi Converter
// Copyright (C) 2002 Tietew
//
#pragma once

#include "resource.h"
#define countof(a) (sizeof(a)/sizeof(*(a)))

extern HINSTANCE g_hinst;
extern volatile bool g_abort;
extern volatile bool g_pause;

#include "plugin.h"
#define WM_FINISH_CONVERT (WM_USER + 100)

bool StartConvert(HWND hwnd, char *source, char *dest, Plugin *p);

class Writer {
	Plugin *m_plugin;
	char *m_folder;
	int m_stage;
	int m_type;
	enum { NONE, FOLDER, MESSAGE };

public:
	Writer(Plugin *plugin, char *folder) : m_plugin(plugin), m_folder(folder)
	{
		m_stage = NONE;
	}
	~Writer()
	{
		if(m_stage == MESSAGE) {
			m_plugin->FinishMessage();
			m_stage = FOLDER;
		}
		if(m_stage == FOLDER)
			m_plugin->FinishFolder();
	}
	
	char *Folder() const
	{
		return m_folder;
	}
	bool NewMessage(int type)
	{
		if(m_stage == MESSAGE) {
			m_stage = FOLDER;
			if(!m_plugin->FinishMessage())
				return false;
		}
		m_type = type;
		return true;
	}
	bool AppendBuffer(const void *buff, DWORD size)
	{
		if(m_stage == NONE) {
			if(!m_plugin->NewFolder(m_folder))
				return false;
			m_stage = FOLDER;
		}
		if(m_stage == FOLDER) {
			if(!m_plugin->NewMessage(m_type))
				return false;
			m_stage = MESSAGE;
		}
		if(!m_plugin->AppendBuffer(buff, size))
			return false;
		return true;
	}
	bool FinishMessage()
	{
		if(m_stage == MESSAGE) {
			m_stage = FOLDER;
			if(!m_plugin->FinishMessage())
				return false;
		}
		return true;
	}
};

class FileAccessor
{
	HANDLE m_fh;
public:
	FileAccessor(HANDLE fh) : m_fh(fh)
	{
	}
	~FileAccessor()
	{
		CloseHandle(m_fh);
	}
	
	DWORD dword(DWORD offs) const
	{
		DWORD data, read, lo;
		LONG hi = 0;
		lo = SetFilePointer(m_fh, offs, &hi, FILE_BEGIN);
		if(hi == 0 && lo == offs)
			if(ReadFile(m_fh, &data, sizeof data, &read, NULL))
				if(read == sizeof data)
					return data;
		return 0;
	}
	bool buffer(BYTE *buffer, DWORD offs, DWORD size) const
	{
		DWORD read, lo;
		LONG hi = 0;
		lo = SetFilePointer(m_fh, offs, &hi, FILE_BEGIN);
		if(hi == 0 && lo == offs)
			if(ReadFile(m_fh, buffer, size, &read, NULL))
				if(read == size)
					return true;
		return NULL;
	}
};
