// OE2bmf.cpp - Outlook-Express-To - OE5/6 Multi Converter
//              bmf (Becky2 Native) writer plugin
// Copyright (C) 2002 Tietew
//
#define WIN32_LEAN_AND_MEAN
#define STRICT
#include <windows.h>
#include <malloc.h>
#pragma hdrstop

#include "resource.h"

#ifndef _DEBUG
#define DllMain _DllMainCRTStartup
#endif

HINSTANCE g_hInstance;

extern "C" BOOL WINAPI DllMain(HINSTANCE module, DWORD reason, LPVOID reserved)
{
	if(reason == DLL_PROCESS_ATTACH) {
		g_hInstance = module;
		DisableThreadLibraryCalls(module);
	}
	return TRUE;
}

extern "C" LPCSTR WINAPI GetPluginName()
{
	return MAKEINTRESOURCE(IDS_PLUGINNAME);
}

extern "C" LPCSTR WINAPI GetNote()
{
	return MAKEINTRESOURCE(IDS_NOTE);
}

extern "C" LPCSTR WINAPI GetDefaultDestDir()
{
	LPSTR result = NULL;
	HKEY hkey;
	if(RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\RimArts\\B2\\Settings", 0, KEY_READ, &hkey) == ERROR_SUCCESS) {
		DWORD type, size;
		if(RegQueryValueEx(hkey, "DataDir", 0, &type, 0, &size) == ERROR_SUCCESS && type == REG_SZ) {
			result = (LPSTR)GlobalAlloc(GMEM_FIXED, size);
			result[0] = '\0';
			RegQueryValueEx(hkey, "DataDir", 0, &type, (LPBYTE)result, &size);
		}
		RegCloseKey(hkey);
	}
	return result;
}

BOOL CALLBACK SettingProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
extern "C" BOOL WINAPI SettingDlg(HWND hwnd)
{
	return DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_SETTING), hwnd, SettingProc);
}

static DWORD gettime()
{
	unsigned __int64 ft;
	GetSystemTimeAsFileTime((LPFILETIME)&ft);
	return (DWORD)((ft - 116444736000000000) / 10000000);
}

HANDLE g_hfile;
DWORD g_size;
DWORD g_bmfname;
UINT g_bmflimit = 640;

extern "C" BOOL WINAPI StartConvert(LPCSTR destdir)
{
	if(!SetCurrentDirectory(destdir))
		return false;
	
	for(DWORD t = gettime(); ; ++t) {
		char mb[12];
		wsprintf(mb, "%08x.mb", t);
		
		WIN32_FIND_DATA fd;
		HANDLE hfind = FindFirstFile(mb, &fd);
		if(hfind == INVALID_HANDLE_VALUE) {
			if(!CreateDirectory(mb, NULL))
				return false;
			if(!SetCurrentDirectory(mb))
				return false;
			if(!WritePrivateProfileString("Account", "Name", "OE2", ".\\Mailbox.ini"))
				return false;
			g_bmfname = t + 1;
			return true;
		}
		FindClose(hfind);
		++t;
	}
	return false;
}

extern "C" BOOL WINAPI NewFolder(LPCSTR folder)
{
	CreateDirectory(folder, NULL);
	return SetCurrentDirectory(folder);
}

extern "C" BOOL WINAPI NewMessage(int type)
{
	if(g_size >= g_bmflimit * 1024) {
		CloseHandle(g_hfile);
		g_size = 0;
		g_hfile = 0;
	}
	if(g_hfile == 0) {
		char bmf[13];
		wsprintf(bmf, "%08x.bmf", ++g_bmfname);
		
		g_hfile = CreateFile(bmf, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if(g_hfile == INVALID_HANDLE_VALUE) {
			g_hfile = 0;
			return false;
		}
	}
	return true;
}

extern "C" BOOL WINAPI AppendBuffer(const void *buff, DWORD size)
{
	DWORD written;
	if(!WriteFile(g_hfile, buff, size, &written, NULL))
		return false;
	g_size += size;
	return true;
}

extern "C" BOOL WINAPI FinishMessage()
{
	return AppendBuffer("\r\n.\r\n", 5);
}

extern "C" BOOL WINAPI FinishFolder()
{
	if(g_hfile != 0) {
		CloseHandle(g_hfile);
		g_hfile = 0;
		g_size = 0;
	}
	return SetCurrentDirectory("..");
}

extern "C" BOOL WINAPI FinishConvert()
{
	return true;
}

BOOL CALLBACK SettingProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch(msg) {
	case WM_INITDIALOG:
		SetDlgItemInt(hwnd, IDC_BMFSIZE, g_bmflimit, false);
		return FALSE;
	
	case WM_COMMAND:
		switch(wp) {
		case IDOK:
			g_bmflimit = GetDlgItemInt(hwnd, IDC_BMFSIZE, NULL, false);
			// fall through
		case IDCANCEL:
			EndDialog(hwnd, wp);
			return TRUE;
		}
		break;
	}
	return FALSE;
}
