// plugin.h - OutlookExpress-To - OE5/6 Multi Converter
// Copyright (C) 2002 Tietew
//
#pragma once
#pragma warning(disable: 4311)

class Plugin
{
	HMODULE module;
	
	LPCSTR (WINAPI *_GetPluginName)();
	LPCSTR (WINAPI *_GetNote)();
	LPCSTR (WINAPI *_GetDefaultDestDir)();
public:
	BOOL (WINAPI *SettingDlg)(HWND hwnd);
	BOOL (WINAPI *StartConvert)(LPCSTR destdir);
	BOOL (WINAPI *NewFolder)(LPCSTR folder);
	BOOL (WINAPI *NewMessage)(int type);
	BOOL (WINAPI *AppendBuffer)(const void *buff, DWORD size);
	BOOL (WINAPI *FinishMessage)();
	BOOL (WINAPI *FinishFolder)();
	BOOL (WINAPI *FinishConvert)();
	
	Plugin() : module(NULL) { }
	~Plugin()
	{
		if(module)
			FreeLibrary(module);
	}
	bool Load(HMODULE mod)
	{
		module = mod;
		(FARPROC&)_GetPluginName = GetProcAddress(module, "GetPluginName");
		(FARPROC&)_GetNote = GetProcAddress(module, "GetNote");
		(FARPROC&)_GetDefaultDestDir = GetProcAddress(module, "GetDefaultDestDir");
		(FARPROC&)SettingDlg = GetProcAddress(module, "SettingDlg");
		(FARPROC&)StartConvert = GetProcAddress(module, "StartConvert");
		(FARPROC&)NewFolder = GetProcAddress(module, "NewFolder");
		(FARPROC&)NewMessage = GetProcAddress(module, "NewMessage");
		(FARPROC&)AppendBuffer = GetProcAddress(module, "AppendBuffer");
		(FARPROC&)FinishMessage = GetProcAddress(module, "FinishMessage");
		(FARPROC&)FinishFolder = GetProcAddress(module, "FinishFolder");
		(FARPROC&)FinishConvert = GetProcAddress(module, "FinishConvert");
		return _GetPluginName && _GetNote && StartConvert && NewFolder
			&& NewMessage && AppendBuffer && FinishMessage;
	}
	char *GetPluginName() const
	{
		return get_string(_GetPluginName);
	}
	char *GetNote() const
	{
		return get_string(_GetNote);
	}
	char *GetDefaultDestDir() const
	{
		return get_string(_GetDefaultDestDir);
	}

private:
	char *get_string(LPCSTR (WINAPI *pfn)()) const
	{
		if(pfn == NULL)
			return NULL;
		LPCSTR str = (*pfn)();
		if(str == NULL)
			return NULL;
		else if((ULONG)str <= 0xFFFF) {
			char rstr[1024];
			LoadString(module, (ULONG)str, rstr, countof(rstr));
			return strdup(rstr);
		} else {
			char *rstr = *str ? strdup(str) : NULL;
			GlobalFree((HGLOBAL)str);
			return rstr;
		}
	}
};
