// utils.cpp - OutlookExpress-To - OE5/6 Multi Converter
// Copyright (C) 2002 Tietew
//
#include "pch.h"
#include "OE2.h"
#include "utils.h"

bool is_win2k()
{
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof osvi;
	GetVersionEx(&osvi);
	return osvi.dwPlatformId == VER_PLATFORM_WIN32_NT && osvi.dwMajorVersion >= 5;
}

int ErrorMessage(HWND hwnd, UINT prefix, UINT error, int type)
{
	char pref[256];
	LoadString(g_hinst, prefix, pref, countof(pref));
	return ErrorMessage(hwnd, pref, error, type);
}

int ErrorMessage(HWND hwnd, LPCSTR prefix, UINT error, int type)
{
	char *lmesg;
	size_t llen, plen;
	
	plen = strlen(prefix);
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM
		| FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL, error, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lmesg, 0, NULL);
	llen = strlen(lmesg);
	
	char *mesg = (char *)_alloca(plen + llen + 3);
	memcpy(mesg, prefix, plen);
	memcpy(mesg + plen, "\r\n", 2);
	memcpy(mesg + plen + 2, lmesg, llen + 1);
	LocalFree(lmesg);
	
	return MyMessageBox(hwnd, mesg, type);
}

int MyMessageBox(HWND hwnd, UINT id, int type)
{
	char mesg[1024];
	LoadString(g_hinst, id, mesg, countof(mesg));
	return MyMessageBox(hwnd, mesg, type);
}

int MyMessageBox(HWND hwnd, LPCSTR mesg, int type)
{
	return MessageBox(hwnd, mesg, "OE2", type);
}

BOOL EnableDlgItem(HWND hdlg, int id, BOOL enable)
{
	return EnableWindow(GetDlgItem(hdlg, id), enable);
}
